<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24" style="margin-top: 10px">
            <Form v-show="searchOpen" id="formId" :label-width="90" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="样品名称:">
                <Input v-model="formObj.name" name="name" placeholder="请输入样品名称" clearable @on-enter="_formSearch"/>
              </Form-item>
              <Form-item class="search-btn">
                <Button type="primary" @click="_formSearch">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" class="contHide"
                      @on-result-change="_btnClick"></btn-list>
          </Col>
          <!--表格-->
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :loading="true"
                        :get-page="getPage" :icon-msg="iconMsg" @on-result-change="_tableResultChange" >
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <span v-if="item.key==='type'">
                      <span v-if="scope.row[item.key]===0">
                          检定
                      </span>
                      <span v-else-if="scope.row[item.key]===1">
                          校准
                      </span>
                       <span v-else-if="scope.row[item.key]===2">
                          外观检查
                      </span>
                  </span>
                  <div v-else-if="item.dateTime">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd HH:MM:ss'):''}}</div>
                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
    <FileManage ref="FileManage"></FileManage>

    <WarehousePersonSelect ref="warehousePersonSelectModal" @on-result-change="_page"></WarehousePersonSelect>
  </div>
</template>
<script>
import { meterDevice, meterSample } from '../../../api'
import WarehousePersonSelect from './WarehousePersonSelect'
export default {
  components: { WarehousePersonSelect },
  data() {
    return {
      currentComponent: '',
      formId: 'meterWarehouseInFormId',
      searchOpen: false,
      btn: [
        // {
        //   type: 'success',
        //   id: '',
        //   name: '入库'
        // }
      ],
      iconMsg: [{ type: 'md-cloud', id: '', name: '附件' }],
      formObj: {
        name: undefined,
        aptitude: undefined
      },
      selectIds: [],
      getPage: {},
      pageColumns: [
        { title: '样品名称', key: 'name', width: 120 },
        { title: '样品编号', key: 'code', width: 120 },
        { title: '入库人', key: 'sampleInner', width: 130 },
        {
          title: '入库时间',
          key: 'sampleInnerTime',
          width: 120,
          dateTime: true
        },
        { title: '出库人', key: 'sampleOuter', width: 130 },
        {
          title: '出库时间',
          key: 'sampleOutTime',
          width: 120,
          dateTime: true
        },
        { title: '型号规格', key: 'spec' },
        { title: '出厂编号', key: 'factoryNumber' },
        { title: '检测类型', key: 'type' },
        { title: '委托单位', key: 'client', width: 200 },
        { title: '联系人', key: 'person', width: 120 },
        { title: '联系电话', key: 'tel', width: 120 },
        { title: '详细地址', key: 'address', width: 250 },
        { title: '数量', key: 'quantity' },
        { title: '备注', key: 'remark' }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '仪器领用':
            this._receiveApparatus()
            break
          case '车辆管理':
            this._carManage()
            break
          case '添加':
            this._editModal(false)
            break
          case '入库':
            this._submitToReview()
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },
    _carManage() {
      this.$refs.carEdit._open()
    },
    _receiveApparatus() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$refs.SelEquip._open('sample-input')
      }
    },
    _submitToReview() {
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$refs.warehousePersonSelectModal._open(ids)
      }
    },
    _submitByContractIds(cont) {
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$Modal.confirm({
          title: '提示',
          content: '确定要把这 ' + ids.length + ' 条记录提交到' + cont + '？',
          onOk: () => {
            const result = meterSample.submit(ids)
            if (result) {
              console.log(result)
            }
          }
        })
      }
    },
    _iconClick(res, data, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (res) {
          case '仪器领用':
            this.$refs.InstruEdit._open()
            break
          case '车辆管理':
            this.$refs.carEdit._open()
            break
          case '编辑':
            // this._editModal(true, data.id)
            this._personModal(data)
            break
          case '资质项目':
            this._itemModal(data.id)
            break
          case '附件':
            this._upload(data.id)
            break
          case '删除':
            this._deleteByIds([data.id])
            break
          case '操作日志':
            this._record(data.id)
            break
        }
      })
    },
    _personModal(data) {
      console.log(data)
      this.$refs.personModal._open(data.id)
    },
    _equipSelectBack(data) {
      console.log('_equipSelectBack', data)
      const equipData = []
      for (let i = 0; i < data.length; i++) {
        const object = data[i]
        const obj = {}
        obj.name = object.name
        obj.certificateNo = object.ceNum
        obj.measuringRange = object.range
        obj.uncertaintyAccuray = object.uncertainty
        obj.validUntil = object.effectDate
        equipData.push(obj)
      }
      this._addEquipUse({ sampleIds: this.selectIds, devicesList: equipData })
    },

    _addEquipUse: async function(data) {
      const result = await meterDevice.addEquipUse(data)
      if (result) {
        await this._page()
      }
    },

    _record(id) {
      this.$refs.refModal._open(id)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          break
        case 'selectIds':
          this.selectIds = data
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await meterSample.pageSampleOutStockHis(this.formObj)
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._delete(ids)
        }
      })
    },
    // 编辑&添加
    _editModal(edit, id) {
      if (edit) {
        // 编辑
        this._getById(id)
      } else {
        // 添加
        this.$refs.editSubcontractorModal._open()
      }
    },
    // 追加项目
    _itemModal(data) {
      this.$refs.refModal._open(data)
    },

    _upload(id) {
      // 上传文件
      this.$refs.FileManage._open(id, 'subcontractorId')
    },
    _getById: async function(id) {
      const result = await meterSample.getById(id)
      if (result) {
        this.$refs.editSubcontractorModal._openEdit(result)
      }
    },
    _delete: async function(ids) {
      const result = await meterSample.deleteById(ids)
      if (result) {
        this._formSearch()
        this.$Message.success('删除成功！')
      }
    }
  }
}
</script>
